diff --git a/CHANGELOG.md b/CHANGELOG.md
index df4c0848..591b8c66 100644
--- a/CHANGELOG.md
+++ b/CHANGELOG.md
@@ -1,5 +1,11 @@
 # Changelog
 
+## [2.4.10](https://github.com/volarjs/volar.js/compare/v2.4.9...v2.4.10) (2024-11-08)
+
+### Bug Fixes
+
+- **typescript:** fix interactive refactors ([#244](https://github.com/volarjs/volar.js/issues/244)) - Thanks to @andrewbranch!
+
 ## [2.4.9](https://github.com/volarjs/volar.js/compare/v2.4.8...v2.4.9) (2024-11-07)
 
 ### Bug Fixes
diff --git a/extensions/labs/package.json b/extensions/labs/package.json
index 17ab54ae..286ec055 100644
--- a/extensions/labs/package.json
+++ b/extensions/labs/package.json
@@ -1,7 +1,7 @@
 {
 	"private": true,
 	"name": "volarjs-labs",
-	"version": "2.4.9",
+	"version": "2.4.10",
 	"repository": {
 		"type": "git",
 		"url": "https://github.com/volarjs/volar.js.git",
@@ -67,9 +67,9 @@
 	"devDependencies": {
 		"@types/node": "latest",
 		"@types/vscode": "^1.82.0",
-		"@volar/language-server": "2.4.9",
-		"@volar/source-map": "2.4.9",
-		"@volar/vscode": "2.4.9",
+		"@volar/language-server": "2.4.10",
+		"@volar/source-map": "2.4.10",
+		"@volar/vscode": "2.4.10",
 		"@vscode/vsce": "latest",
 		"esbuild": "latest",
 		"esbuild-plugin-copy": "latest",
diff --git a/lerna.json b/lerna.json
index 28612b61..26aa7db5 100644
--- a/lerna.json
+++ b/lerna.json
@@ -5,5 +5,5 @@
 		"extensions/*",
 		"packages/*"
 	],
-	"version": "2.4.9"
+	"version": "2.4.10"
 }
diff --git a/packages/eslint/package.json b/packages/eslint/package.json
index c83a3256..8c9fddf4 100644
--- a/packages/eslint/package.json
+++ b/packages/eslint/package.json
@@ -1,6 +1,6 @@
 {
 	"name": "@volar/eslint",
-	"version": "2.4.9",
+	"version": "2.4.10",
 	"license": "MIT",
 	"files": [
 		"**/*.js",
@@ -13,7 +13,7 @@
 	},
 	"dependencies": {
 		"@types/eslint": "^8.56.10",
-		"@volar/language-core": "2.4.9",
+		"@volar/language-core": "2.4.10",
 		"vscode-languageserver-textdocument": "^1.0.11"
 	}
 }
diff --git a/packages/jsdelivr/package.json b/packages/jsdelivr/package.json
index 7f4122c9..5bcfd638 100644
--- a/packages/jsdelivr/package.json
+++ b/packages/jsdelivr/package.json
@@ -1,6 +1,6 @@
 {
 	"name": "@volar/jsdelivr",
-	"version": "2.4.9",
+	"version": "2.4.10",
 	"license": "MIT",
 	"files": [
 		"**/*.js",
@@ -12,7 +12,7 @@
 		"directory": "packages/jsdelivr"
 	},
 	"devDependencies": {
-		"@volar/language-service": "2.4.9",
+		"@volar/language-service": "2.4.10",
 		"vscode-uri": "^3.0.8"
 	}
 }
diff --git a/packages/kit/package.json b/packages/kit/package.json
index 28dfe4d2..96f89fdf 100644
--- a/packages/kit/package.json
+++ b/packages/kit/package.json
@@ -1,6 +1,6 @@
 {
 	"name": "@volar/kit",
-	"version": "2.4.9",
+	"version": "2.4.10",
 	"license": "MIT",
 	"files": [
 		"**/*.js",
@@ -12,8 +12,8 @@
 		"directory": "packages/kit"
 	},
 	"dependencies": {
-		"@volar/language-service": "2.4.9",
-		"@volar/typescript": "2.4.9",
+		"@volar/language-service": "2.4.10",
+		"@volar/typescript": "2.4.10",
 		"typesafe-path": "^0.2.2",
 		"vscode-languageserver-textdocument": "^1.0.11",
 		"vscode-uri": "^3.0.8"
diff --git a/packages/language-core/package.json b/packages/language-core/package.json
index 95445f04..7e21c8fc 100644
--- a/packages/language-core/package.json
+++ b/packages/language-core/package.json
@@ -1,6 +1,6 @@
 {
 	"name": "@volar/language-core",
-	"version": "2.4.9",
+	"version": "2.4.10",
 	"license": "MIT",
 	"files": [
 		"**/*.js",
@@ -12,6 +12,6 @@
 		"directory": "packages/language-core"
 	},
 	"dependencies": {
-		"@volar/source-map": "2.4.9"
+		"@volar/source-map": "2.4.10"
 	}
 }
diff --git a/packages/language-server/package.json b/packages/language-server/package.json
index 2086a92d..a41e93a1 100644
--- a/packages/language-server/package.json
+++ b/packages/language-server/package.json
@@ -1,6 +1,6 @@
 {
 	"name": "@volar/language-server",
-	"version": "2.4.9",
+	"version": "2.4.10",
 	"license": "MIT",
 	"files": [
 		"**/*.js",
@@ -12,9 +12,9 @@
 		"directory": "packages/language-server"
 	},
 	"dependencies": {
-		"@volar/language-core": "2.4.9",
-		"@volar/language-service": "2.4.9",
-		"@volar/typescript": "2.4.9",
+		"@volar/language-core": "2.4.10",
+		"@volar/language-service": "2.4.10",
+		"@volar/typescript": "2.4.10",
 		"path-browserify": "^1.0.1",
 		"request-light": "^0.7.0",
 		"vscode-languageserver": "^9.0.1",
diff --git a/packages/language-service/package.json b/packages/language-service/package.json
index 71fe637e..8eeb2083 100644
--- a/packages/language-service/package.json
+++ b/packages/language-service/package.json
@@ -1,6 +1,6 @@
 {
 	"name": "@volar/language-service",
-	"version": "2.4.9",
+	"version": "2.4.10",
 	"license": "MIT",
 	"files": [
 		"**/*.js",
@@ -12,7 +12,7 @@
 		"directory": "packages/language-service"
 	},
 	"dependencies": {
-		"@volar/language-core": "2.4.9",
+		"@volar/language-core": "2.4.10",
 		"vscode-languageserver-protocol": "^3.17.5",
 		"vscode-languageserver-textdocument": "^1.0.11",
 		"vscode-uri": "^3.0.8"
diff --git a/packages/monaco/package.json b/packages/monaco/package.json
index 01710f71..76991971 100644
--- a/packages/monaco/package.json
+++ b/packages/monaco/package.json
@@ -1,6 +1,6 @@
 {
 	"name": "@volar/monaco",
-	"version": "2.4.9",
+	"version": "2.4.10",
 	"license": "MIT",
 	"type": "module",
 	"files": [
@@ -13,8 +13,8 @@
 		"directory": "packages/monaco"
 	},
 	"dependencies": {
-		"@volar/language-service": "2.4.9",
-		"@volar/typescript": "2.4.9",
+		"@volar/language-service": "2.4.10",
+		"@volar/typescript": "2.4.10",
 		"monaco-languageserver-types": "^0.4.0",
 		"monaco-types": "^0.1.0",
 		"vscode-uri": "^3.0.8"
diff --git a/packages/source-map/package.json b/packages/source-map/package.json
index b56566a5..77676980 100644
--- a/packages/source-map/package.json
+++ b/packages/source-map/package.json
@@ -1,6 +1,6 @@
 {
 	"name": "@volar/source-map",
-	"version": "2.4.9",
+	"version": "2.4.10",
 	"license": "MIT",
 	"files": [
 		"**/*.js",
diff --git a/packages/test-utils/package.json b/packages/test-utils/package.json
index 943ac4ce..36465fd3 100644
--- a/packages/test-utils/package.json
+++ b/packages/test-utils/package.json
@@ -1,6 +1,6 @@
 {
 	"name": "@volar/test-utils",
-	"version": "2.4.9",
+	"version": "2.4.10",
 	"license": "MIT",
 	"files": [
 		"**/*.js",
@@ -15,8 +15,8 @@
 		"@types/node": "latest"
 	},
 	"dependencies": {
-		"@volar/language-core": "2.4.9",
-		"@volar/language-server": "2.4.9",
+		"@volar/language-core": "2.4.10",
+		"@volar/language-server": "2.4.10",
 		"vscode-languageserver-textdocument": "^1.0.11",
 		"vscode-uri": "^3.0.8"
 	}
diff --git a/packages/typescript/lib/node/proxyLanguageService.ts b/packages/typescript/lib/node/proxyLanguageService.ts
index 39b99e0d..b6cc56da 100644
--- a/packages/typescript/lib/node/proxyLanguageService.ts
+++ b/packages/typescript/lib/node/proxyLanguageService.ts
@@ -485,7 +485,7 @@ function getApplicableRefactors(language: Language<string>, getApplicableRefacto
 	};
 }
 function getEditsForRefactor(language: Language<string>, getEditsForRefactor: ts.LanguageService['getEditsForRefactor']): ts.LanguageService['getEditsForRefactor'] {
-	return (filePath, formatOptions, positionOrRange, refactorName, actionName, preferences) => {
+	return (filePath, formatOptions, positionOrRange, refactorName, actionName, preferences, interactiveRefactorArguments) => {
 		let edits: ts.RefactorEditInfo | undefined;
 		const fileName = filePath.replace(windowsPathReg, '/');
 		const [serviceScript, targetScript, sourceScript] = getServiceScript(language, fileName);
@@ -496,17 +496,17 @@ function getEditsForRefactor(language: Language<string>, getEditsForRefactor: ts
 			if (typeof positionOrRange === 'number') {
 				const generatePosition = toGeneratedOffset(language, serviceScript, sourceScript, positionOrRange, isCodeActionsEnabled);
 				if (generatePosition !== undefined) {
-					edits = getEditsForRefactor(targetScript.id, formatOptions, generatePosition, refactorName, actionName, preferences);
+					edits = getEditsForRefactor(targetScript.id, formatOptions, generatePosition, refactorName, actionName, preferences, interactiveRefactorArguments);
 				}
 			}
 			else {
 				for (const [generatedStart, generatedEnd] of toGeneratedRanges(language, serviceScript, sourceScript, positionOrRange.pos, positionOrRange.end, isCodeActionsEnabled)) {
-					edits = getEditsForRefactor(targetScript.id, formatOptions, { pos: generatedStart, end: generatedEnd }, refactorName, actionName, preferences);
+					edits = getEditsForRefactor(targetScript.id, formatOptions, { pos: generatedStart, end: generatedEnd }, refactorName, actionName, preferences, interactiveRefactorArguments);
 				}
 			}
 		}
 		else {
-			edits = getEditsForRefactor(fileName, formatOptions, positionOrRange, refactorName, actionName, preferences);
+			edits = getEditsForRefactor(fileName, formatOptions, positionOrRange, refactorName, actionName, preferences, interactiveRefactorArguments);
 		}
 		if (edits) {
 			edits.edits = transformFileTextChanges(language, edits.edits, false, isCodeActionsEnabled);
diff --git a/packages/typescript/package.json b/packages/typescript/package.json
index a0afa9b8..41edac15 100644
--- a/packages/typescript/package.json
+++ b/packages/typescript/package.json
@@ -1,6 +1,6 @@
 {
 	"name": "@volar/typescript",
-	"version": "2.4.9",
+	"version": "2.4.10",
 	"license": "MIT",
 	"files": [
 		"**/*.js",
@@ -12,13 +12,13 @@
 		"directory": "packages/typescript"
 	},
 	"dependencies": {
-		"@volar/language-core": "2.4.9",
+		"@volar/language-core": "2.4.10",
 		"path-browserify": "^1.0.1",
 		"vscode-uri": "^3.0.8"
 	},
 	"devDependencies": {
 		"@types/node": "latest",
 		"@types/path-browserify": "latest",
-		"@volar/language-service": "2.4.9"
+		"@volar/language-service": "2.4.10"
 	}
 }
diff --git a/packages/vscode/package.json b/packages/vscode/package.json
index 0ba8e015..4d0c69ba 100644
--- a/packages/vscode/package.json
+++ b/packages/vscode/package.json
@@ -1,6 +1,6 @@
 {
 	"name": "@volar/vscode",
-	"version": "2.4.9",
+	"version": "2.4.10",
 	"license": "MIT",
 	"files": [
 		"**/*.js",
@@ -12,7 +12,7 @@
 		"directory": "packages/vscode"
 	},
 	"dependencies": {
-		"@volar/language-server": "2.4.9",
+		"@volar/language-server": "2.4.10",
 		"path-browserify": "^1.0.1",
 		"vscode-languageclient": "^9.0.1",
 		"vscode-nls": "^5.2.0"
diff --git a/pnpm-lock.yaml b/pnpm-lock.yaml
index bc6d4628..df6da04b 100644
--- a/pnpm-lock.yaml
+++ b/pnpm-lock.yaml
@@ -16,7 +16,7 @@ importers:
         version: 3.10.0(@types/node@22.9.0)(typescript@5.6.3)
       '@tsslint/cli':
         specifier: latest
-        version: 1.1.3(typescript@5.6.3)
+        version: 1.1.4(typescript@5.6.3)
       typescript:
         specifier: latest
         version: 5.6.3
@@ -36,13 +36,13 @@ importers:
         specifier: ^1.82.0
         version: 1.95.0
       '@volar/language-server':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../../packages/language-server
       '@volar/source-map':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../../packages/source-map
       '@volar/vscode':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../../packages/vscode
       '@vscode/vsce':
         specifier: latest
@@ -63,7 +63,7 @@ importers:
         specifier: ^8.56.10
         version: 8.56.12
       '@volar/language-core':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../language-core
       vscode-languageserver-textdocument:
         specifier: ^1.0.11
@@ -72,7 +72,7 @@ importers:
   packages/jsdelivr:
     devDependencies:
       '@volar/language-service':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../language-service
       vscode-uri:
         specifier: ^3.0.8
@@ -81,10 +81,10 @@ importers:
   packages/kit:
     dependencies:
       '@volar/language-service':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../language-service
       '@volar/typescript':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../typescript
       typesafe-path:
         specifier: ^0.2.2
@@ -106,19 +106,19 @@ importers:
   packages/language-core:
     dependencies:
       '@volar/source-map':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../source-map
 
   packages/language-server:
     dependencies:
       '@volar/language-core':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../language-core
       '@volar/language-service':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../language-service
       '@volar/typescript':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../typescript
       path-browserify:
         specifier: ^1.0.1
@@ -146,7 +146,7 @@ importers:
   packages/language-service:
     dependencies:
       '@volar/language-core':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../language-core
       vscode-languageserver-protocol:
         specifier: ^3.17.5
@@ -161,10 +161,10 @@ importers:
   packages/monaco:
     dependencies:
       '@volar/language-service':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../language-service
       '@volar/typescript':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../typescript
       monaco-languageserver-types:
         specifier: ^0.4.0
@@ -185,10 +185,10 @@ importers:
   packages/test-utils:
     dependencies:
       '@volar/language-core':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../language-core
       '@volar/language-server':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../language-server
       vscode-languageserver-textdocument:
         specifier: ^1.0.11
@@ -204,7 +204,7 @@ importers:
   packages/typescript:
     dependencies:
       '@volar/language-core':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../language-core
       path-browserify:
         specifier: ^1.0.1
@@ -220,13 +220,13 @@ importers:
         specifier: latest
         version: 1.0.3
       '@volar/language-service':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../language-service
 
   packages/vscode:
     dependencies:
       '@volar/language-server':
-        specifier: 2.4.9
+        specifier: 2.4.10
         version: link:../language-server
       path-browserify:
         specifier: ^1.0.1
@@ -929,20 +929,20 @@ packages:
     resolution: {integrity: sha512-8iKx79/F73DKbGfRf7+t4dqrc0bRr0thdPrxAtCKWRm/F0tG71i6O1rvlnScncJLLBZHn3h8M3c1BSUAb9yu8g==}
     engines: {node: ^16.14.0 || >=18.0.0}
 
-  '@tsslint/cli@1.1.3':
-    resolution: {integrity: sha512-6W2ARpGowGQf0a/0nlo4dOveJ2Lg62HDVrXzofT+PRbb4LAP7McjzvOrmZA+FRfnzCrPehX+ZT1XT9RvKHYCsg==}
+  '@tsslint/cli@1.1.4':
+    resolution: {integrity: sha512-AUv9SlJc8p8vthsCEE+kB150gqys1OZnPiqphZfkBLE0pegTVrZhvf2bibnQruSNY+VIWH/IWVNDV1bjd9uiwQ==}
     hasBin: true
     peerDependencies:
       typescript: '*'
 
-  '@tsslint/config@1.1.3':
-    resolution: {integrity: sha512-ZttaRm/UAUM9G5ZRwczRx+PW81w4tG1JBIp2cAT9ad0CXLWs+H78DCd2fq3F+iXDys/pE4UB+OzLi+EIiJaYBQ==}
+  '@tsslint/config@1.1.4':
+    resolution: {integrity: sha512-aSsJyZT/htyp5+j8LtND1pEazMvKGY9e6BvyAZntrudRnRZH4hCfMX05AkJz4lcuX3uc+7sDhqiX+FqCE/PdiA==}
 
-  '@tsslint/core@1.1.3':
-    resolution: {integrity: sha512-bi7gVuCsdEs8HA/kT9xzNwX/xWgih5/vRV5oDDikqEsyMp7AnAd//XPangPgVe1VegtMeN9xLAwdSZJJt4zvIg==}
+  '@tsslint/core@1.1.4':
+    resolution: {integrity: sha512-0YRXooX4YmizYHp/KS6S5HPO6/q9J/kk7Uad+pzPVcuh9Hiy65o5SJLrIFTpwh2GMAKe52NK2qaIJ6t3x0u0GA==}
 
-  '@tsslint/types@1.1.3':
-    resolution: {integrity: sha512-MNrRUtnMuP4epzV+uc4j1n+1dMIk3xe3XFfzCLIFDiNBzWzV59BSyEDOgsniewY5XTZEg6fWvccqs0wVp1hS/g==}
+  '@tsslint/types@1.1.4':
+    resolution: {integrity: sha512-mW8y2AXn2XmGGMxt7ff4jD5m6i5ywo9LNBOgw/bserRkIKNLcNq5d0g0IKBynhVPfgTJskG2uLT0csbPGbQjaQ==}
 
   '@tufjs/canonical-json@2.0.0':
     resolution: {integrity: sha512-yVtV8zsdo8qFHe+/3kw81dSLyF7D576A5cCFCi4X7B39tWT7SekaEFUnvnWJHz+9qO7qJTah1JbrDjWKqFtdWA==}
@@ -3841,27 +3841,27 @@ snapshots:
       '@sigstore/core': 1.1.0
       '@sigstore/protobuf-specs': 0.3.2
 
-  '@tsslint/cli@1.1.3(typescript@5.6.3)':
+  '@tsslint/cli@1.1.4(typescript@5.6.3)':
     dependencies:
       '@clack/prompts': 0.7.0
-      '@tsslint/config': 1.1.3
-      '@tsslint/core': 1.1.3
+      '@tsslint/config': 1.1.4
+      '@tsslint/core': 1.1.4
       glob: 10.4.5
       typescript: 5.6.3
 
-  '@tsslint/config@1.1.3':
+  '@tsslint/config@1.1.4':
     dependencies:
-      '@tsslint/types': 1.1.3
+      '@tsslint/types': 1.1.4
 
-  '@tsslint/core@1.1.3':
+  '@tsslint/core@1.1.4':
     dependencies:
-      '@tsslint/types': 1.1.3
+      '@tsslint/types': 1.1.4
       error-stack-parser: 2.1.4
       esbuild: 0.24.0
       minimatch: 10.0.1
       source-map-support: 0.5.21
 
-  '@tsslint/types@1.1.3': {}
+  '@tsslint/types@1.1.4': {}
 
   '@tufjs/canonical-json@2.0.0': {}
 
